import { Component, EventEmitter, ChangeDetectionStrategy, ElementRef, Renderer2, Inject, Input, Output, ViewChild, ContentChildren, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { Platform } from '@ionic/angular';
import { HammerGestureConfig, HAMMER_GESTURE_CONFIG } from '@angular/platform-browser';
import { DIRECTION_VERTICAL } from 'hammerjs';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class IonicPullupComponentTabComponent {
}
IonicPullupComponentTabComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-ionic-pullup-tab',
                template: "<ng-content></ng-content>",
                styles: [":host{z-index:1000;display:-webkit-box;display:flex;-webkit-box-pack:center;justify-content:center;position:relative;width:120px;height:10px;background:var(--ion-color-primary);color:#fff;border-radius:10px 10px 0 0;margin:0 auto}"]
            }] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function FooterMetadata() { }
if (false) {
    /** @type {?} */
    FooterMetadata.prototype.height;
    /** @type {?} */
    FooterMetadata.prototype.posY;
    /** @type {?} */
    FooterMetadata.prototype.lastPosY;
    /** @type {?|undefined} */
    FooterMetadata.prototype.toolbarDefaultHeight;
    /** @type {?|undefined} */
    FooterMetadata.prototype.toolbarDefaultExpandedPosition;
    /** @type {?|undefined} */
    FooterMetadata.prototype.toolbarUpperBoundary;
    /** @type {?|undefined} */
    FooterMetadata.prototype.ionContentRef;
}
/**
 * @record
 */
function ViewMetadata() { }
if (false) {
    /** @type {?|undefined} */
    ViewMetadata.prototype.tabs;
    /** @type {?|undefined} */
    ViewMetadata.prototype.tabsHeight;
    /** @type {?|undefined} */
    ViewMetadata.prototype.hasBottomTabs;
    /** @type {?|undefined} */
    ViewMetadata.prototype.header;
    /** @type {?|undefined} */
    ViewMetadata.prototype.headerHeight;
    /** @type {?|undefined} */
    ViewMetadata.prototype.bottomSpace;
}
/**
 * @record
 */
function FooterTab() { }
if (false) {
    /** @type {?|undefined} */
    FooterTab.prototype.x;
    /** @type {?|undefined} */
    FooterTab.prototype.y;
    /** @type {?|undefined} */
    FooterTab.prototype.upperLeftRadius;
    /** @type {?|undefined} */
    FooterTab.prototype.upperRightRadius;
    /** @type {?|undefined} */
    FooterTab.prototype.backgroundColor;
    /** @type {?|undefined} */
    FooterTab.prototype.color;
    /** @type {?|undefined} */
    FooterTab.prototype.content;
}
/** @enum {number} */
const IonPullUpFooterState = {
    Collapsed: 0,
    Expanded: 1,
    Minimized: 2,
};
IonPullUpFooterState[IonPullUpFooterState.Collapsed] = 'Collapsed';
IonPullUpFooterState[IonPullUpFooterState.Expanded] = 'Expanded';
IonPullUpFooterState[IonPullUpFooterState.Minimized] = 'Minimized';
/** @enum {number} */
const IonPullUpFooterBehavior = {
    Hide: 0,
    Expand: 1,
};
IonPullUpFooterBehavior[IonPullUpFooterBehavior.Hide] = 'Hide';
IonPullUpFooterBehavior[IonPullUpFooterBehavior.Expand] = 'Expand';
class IonicPullupComponent {
    /**
     * @param {?} platform
     * @param {?} el
     * @param {?} renderer
     * @param {?} hammerConfig
     */
    constructor(platform, el, renderer, hammerConfig) {
        this.platform = platform;
        this.el = el;
        this.renderer = renderer;
        this.hammerConfig = hammerConfig;
        this.stateChange = new EventEmitter();
        this.expanded = new EventEmitter();
        this.collapsed = new EventEmitter();
        this.minimized = new EventEmitter();
        this.footerMeta = {
            height: 0,
            posY: 0,
            lastPosY: 0
        };
        this.currentViewMeta = { bottomSpace: screen.height - window.innerHeight };
        // sets initial state
        this.initialState = this.initialState || IonPullUpFooterState.Collapsed;
        this.defaultBehavior = this.defaultBehavior || IonPullUpFooterBehavior.Expand;
        this.maxHeight = this.maxHeight || 0;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        console.log('ionic-pullup => Initializing footer...');
        window.addEventListener('orientationchange', (/**
         * @return {?}
         */
        () => {
            console.log('ionic-pullup => Changed orientation => updating');
            this.updateUI();
        }));
        this.platform.resume.subscribe((/**
         * @return {?}
         */
        () => {
            console.log('ionic-pullup => Resumed from background => updating');
            this.updateUI();
        }));
    }
    /**
     * @return {?}
     */
    ngAfterContentInit() {
        this.computeDefaults();
        this.state = IonPullUpFooterState.Collapsed;
        this.updateUI();
    }
    /**
     * @return {?}
     */
    get expandedHeight() {
        return window.innerHeight - this.currentViewMeta.headerHeight - this.currentViewMeta.tabsHeight;
    }
    /**
     * @return {?}
     */
    computeDefaults() {
        setTimeout((/**
         * @return {?}
         */
        () => {
            this.footerMeta.toolbarDefaultHeight = this.childFooter.nativeElement.offsetHeight;
            this.currentViewMeta.tabs = document.querySelector('ion-tab-bar');
            this.currentViewMeta.tabsHeight = this.currentViewMeta.tabs ? ((/** @type {?} */ (this.currentViewMeta.tabs))).offsetHeight : 0;
            console.log(this.currentViewMeta.tabsHeight ? 'ionic-pullup => Tabs detected' : 'ionic.pullup => View has no tabs');
            this.currentViewMeta.header = document.querySelector('ion-toolbar');
            this.currentViewMeta.headerHeight = this.currentViewMeta.header.clientHeight;
            this.footerMeta.ionContentRef = this.childFooter.nativeElement.querySelector('ion-content');
            this.dragElements.forEach((/**
             * @param {?} elem
             * @return {?}
             */
            elem => {
                /** @type {?} */
                const hammer = this.hammerConfig.buildHammer(elem.el);
                hammer.on('pan panstart panend', (/**
                 * @param {?} ev
                 * @return {?}
                 */
                (ev) => {
                    this.onPan(ev);
                }));
            }));
        }), 300);
    }
    /**
     * @return {?}
     */
    computeHeights() {
        this.footerMeta.height = this.maxHeight > 0 ? this.maxHeight : this.expandedHeight;
        this.footerMeta.toolbarDefaultExpandedPosition = -this.footerMeta.height + this.footerMeta.toolbarDefaultHeight;
        this.footerMeta.toolbarUpperBoundary = this.footerMeta.height - this.currentViewMeta.headerHeight;
        this.renderer.setStyle(this.childFooter.nativeElement, 'height', this.footerMeta.height + 'px');
        this.renderer.setStyle(this.childFooter.nativeElement, 'top', window.innerHeight - this.footerMeta.toolbarDefaultHeight - this.currentViewMeta.tabsHeight + 'px');
        // TODO check if this is needed for native platform iOS/Android
        // this.renderer.setStyle(this.childFooter.nativeElement, 'bottom', this.currentViewMeta.tabsHeight + 'px');
    }
    /**
     * @param {?=} isInit
     * @return {?}
     */
    updateUI(isInit = false) {
        if (!this.childFooter) {
            return;
        }
        setTimeout((/**
         * @return {?}
         */
        () => {
            this.computeHeights();
        }), 300);
        this.renderer.setStyle(this.childFooter.nativeElement, 'transition', 'none'); // avoids flickering when changing orientation
    }
    /**
     * @return {?}
     */
    expand() {
        console.log('Expand', this.childFooter);
        this.footerMeta.lastPosY = this.footerMeta.toolbarDefaultExpandedPosition;
        // reset ionContent scaling
        this.renderer.setStyle(this.footerMeta.ionContentRef, 'max-height', '100%');
        this.renderer.setStyle(this.childFooter.nativeElement, '-webkit-transform', `translate3d(0, ${this.footerMeta.lastPosY}px, 0)`);
        this.renderer.setStyle(this.childFooter.nativeElement, 'transform', `translate3d(0, ${this.footerMeta.lastPosY}px, 0)`);
        this.renderer.setStyle(this.childFooter.nativeElement, 'transition', '300ms ease-in-out');
        this.expanded.emit(null);
    }
    /**
     * @param {?=} isInit
     * @return {?}
     */
    collapse(isInit = false) {
        console.log('Collapse', this.childFooter);
        if (!this.childFooter) {
            return;
        }
        this.footerMeta.lastPosY = 0;
        // reset ionContent scaling
        this.renderer.setStyle(this.footerMeta.ionContentRef, 'max-height', '100%');
        this.renderer.setStyle(this.childFooter.nativeElement, '-webkit-transform', `translate3d(0, ${this.footerMeta.lastPosY}px, 0)`);
        this.renderer.setStyle(this.childFooter.nativeElement, 'transform', `translate3d(0, ${this.footerMeta.lastPosY}px, 0)`);
        if (!isInit) {
            this.collapsed.emit(null);
        }
    }
    /**
     * TODO
     * @return {?}
     */
    minimize() {
        this.footerMeta.lastPosY = this.footerMeta.height;
        this.renderer.setStyle(this.childFooter.nativeElement, '-webkit-transform', 'translate3d(0, ' + this.footerMeta.lastPosY + 'px, 0)');
        this.renderer.setStyle(this.childFooter.nativeElement, 'transform', 'translate3d(0, ' + this.footerMeta.lastPosY + 'px, 0)');
        this.minimized.emit(null);
    }
    /**
     * @param {?} e
     * @return {?}
     */
    onTap(e) {
        e.preventDefault();
        if (this.state === IonPullUpFooterState.Collapsed) {
            if (this.defaultBehavior === IonPullUpFooterBehavior.Hide) {
                this.state = IonPullUpFooterState.Minimized;
            }
            else {
                this.state = IonPullUpFooterState.Expanded;
            }
        }
        else {
            if (this.state === IonPullUpFooterState.Minimized) {
                if (this.defaultBehavior === IonPullUpFooterBehavior.Hide) {
                    this.state = IonPullUpFooterState.Collapsed;
                }
                else {
                    this.state = IonPullUpFooterState.Expanded;
                }
            }
            else {
                // footer is expanded
                this.state = this.initialState === IonPullUpFooterState.Minimized ? IonPullUpFooterState.Minimized : IonPullUpFooterState.Collapsed;
            }
        }
    }
    /**
     * @param {?} e
     * @return {?}
     */
    onPan(e) {
        this.renderer.setStyle(this.childFooter.nativeElement, 'transition', 'none');
        e.preventDefault();
        switch (e.type) {
            case 'pan':
                this.footerMeta.posY = e.deltaY + this.footerMeta.lastPosY;
                // check for min and max boundaries overflow with sliding gesture
                if (this.footerMeta.posY > 0) {
                    this.footerMeta.posY = 0;
                    // return;
                }
                else if (Math.abs(this.footerMeta.posY) > this.footerMeta.toolbarUpperBoundary) {
                    this.footerMeta.posY = this.footerMeta.toolbarDefaultExpandedPosition;
                }
                // ionContent scaling - FIX scrolling bug
                if (this.footerMeta.ionContentRef) {
                    /** @type {?} */
                    const scaleFactor = Math.abs(this.footerMeta.posY) / this.footerMeta.toolbarUpperBoundary;
                    this.renderer.setStyle(this.footerMeta.ionContentRef, 'max-height', `${scaleFactor * 100}%`);
                }
                this.renderer.setStyle(this.childFooter.nativeElement, '-webkit-transform', 'translate3d(0, ' + this.footerMeta.posY + 'px, 0)');
                this.renderer.setStyle(this.childFooter.nativeElement, 'transform', 'translate3d(0, ' + this.footerMeta.posY + 'px, 0)');
                break;
            case 'panend':
                this.renderer.setStyle(this.childFooter.nativeElement, 'transition', '300ms ease-in-out');
                this.footerMeta.lastPosY = this.footerMeta.posY;
                // TODO auto dock
                // if (this.footerMeta.lastPosY > this.footerMeta.height - this.footerMeta.defaultHeight) {
                //   this.state =  IonPullUpFooterState.Collapsed;
                // }
                break;
        }
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        console.log(changes);
        if (changes.state.isFirstChange() || changes.state.currentValue === changes.state.previousValue) {
            return;
        }
        switch (this.state) {
            case IonPullUpFooterState.Collapsed:
                this.collapse();
                break;
            case IonPullUpFooterState.Expanded:
                this.expand();
                break;
            case IonPullUpFooterState.Minimized:
                this.minimize();
                break;
        }
        // this.oldState = this.state;
        // TODO: fix hack due to BUG (https://github.com/angular/angular/issues/6005)
        window.setTimeout((/**
         * @return {?}
         */
        () => {
            this.stateChange.emit(this.state);
        }));
    }
}
IonicPullupComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-ionic-pullup',
                template: "<div class=\"footer\" #footer>\n  <ng-content></ng-content>\n</div>",
                changeDetection: ChangeDetectionStrategy.OnPush,
                styles: [".footer{left:0;right:0;position:fixed}"]
            }] }
];
/** @nocollapse */
IonicPullupComponent.ctorParameters = () => [
    { type: Platform },
    { type: ElementRef },
    { type: Renderer2 },
    { type: HammerGestureConfig, decorators: [{ type: Inject, args: [HAMMER_GESTURE_CONFIG,] }] }
];
IonicPullupComponent.propDecorators = {
    state: [{ type: Input }],
    stateChange: [{ type: Output }],
    initialState: [{ type: Input }],
    defaultBehavior: [{ type: Input }],
    maxHeight: [{ type: Input }],
    expanded: [{ type: Output }],
    collapsed: [{ type: Output }],
    minimized: [{ type: Output }],
    childFooter: [{ type: ViewChild, args: ['footer', { static: true },] }],
    dragElements: [{ type: ContentChildren, args: ['ionDragFooter',] }]
};
if (false) {
    /** @type {?} */
    IonicPullupComponent.prototype.state;
    /** @type {?} */
    IonicPullupComponent.prototype.stateChange;
    /** @type {?} */
    IonicPullupComponent.prototype.initialState;
    /** @type {?} */
    IonicPullupComponent.prototype.defaultBehavior;
    /** @type {?} */
    IonicPullupComponent.prototype.maxHeight;
    /** @type {?} */
    IonicPullupComponent.prototype.expanded;
    /** @type {?} */
    IonicPullupComponent.prototype.collapsed;
    /** @type {?} */
    IonicPullupComponent.prototype.minimized;
    /** @type {?} */
    IonicPullupComponent.prototype.childFooter;
    /** @type {?} */
    IonicPullupComponent.prototype.dragElements;
    /**
     * @type {?}
     * @protected
     */
    IonicPullupComponent.prototype.footerMeta;
    /**
     * @type {?}
     * @protected
     */
    IonicPullupComponent.prototype.currentViewMeta;
    /**
     * @type {?}
     * @protected
     */
    IonicPullupComponent.prototype.oldState;
    /**
     * @type {?}
     * @private
     */
    IonicPullupComponent.prototype.platform;
    /**
     * @type {?}
     * @private
     */
    IonicPullupComponent.prototype.el;
    /**
     * @type {?}
     * @private
     */
    IonicPullupComponent.prototype.renderer;
    /**
     * @type {?}
     * @private
     */
    IonicPullupComponent.prototype.hammerConfig;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MyHammerConfig extends HammerGestureConfig {
    constructor() {
        super(...arguments);
        this.overrides = {
            pan: { direction: DIRECTION_VERTICAL },
        };
    }
}
if (false) {
    /** @type {?} */
    MyHammerConfig.prototype.overrides;
}
class IonicPullupModule {
}
IonicPullupModule.decorators = [
    { type: NgModule, args: [{
                declarations: [IonicPullupComponent, IonicPullupComponentTabComponent],
                imports: [],
                exports: [IonicPullupComponent, IonicPullupComponentTabComponent],
                schemas: [CUSTOM_ELEMENTS_SCHEMA],
                providers: [
                    {
                        provide: HAMMER_GESTURE_CONFIG,
                        useClass: MyHammerConfig,
                    },
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { IonPullUpFooterBehavior, IonPullUpFooterState, IonicPullupComponent, IonicPullupComponentTabComponent, IonicPullupModule, MyHammerConfig };
//# sourceMappingURL=ionic-pullup.js.map
