import { Component, EventEmitter, ChangeDetectionStrategy, ElementRef, Renderer2, Inject, Input, Output, ViewChild, ContentChildren, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { Platform } from '@ionic/angular';
import { HammerGestureConfig, HAMMER_GESTURE_CONFIG } from '@angular/platform-browser';
import { __extends } from 'tslib';
import { DIRECTION_VERTICAL } from 'hammerjs';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var IonicPullupComponentTabComponent = /** @class */ (function () {
    function IonicPullupComponentTabComponent() {
    }
    IonicPullupComponentTabComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-ionic-pullup-tab',
                    template: "<ng-content></ng-content>",
                    styles: [":host{z-index:1000;display:-webkit-box;display:flex;-webkit-box-pack:center;justify-content:center;position:relative;width:120px;height:10px;background:var(--ion-color-primary);color:#fff;border-radius:10px 10px 0 0;margin:0 auto}"]
                }] }
    ];
    return IonicPullupComponentTabComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function FooterMetadata() { }
if (false) {
    /** @type {?} */
    FooterMetadata.prototype.height;
    /** @type {?} */
    FooterMetadata.prototype.posY;
    /** @type {?} */
    FooterMetadata.prototype.lastPosY;
    /** @type {?|undefined} */
    FooterMetadata.prototype.toolbarDefaultHeight;
    /** @type {?|undefined} */
    FooterMetadata.prototype.toolbarDefaultExpandedPosition;
    /** @type {?|undefined} */
    FooterMetadata.prototype.toolbarUpperBoundary;
    /** @type {?|undefined} */
    FooterMetadata.prototype.ionContentRef;
}
/**
 * @record
 */
function ViewMetadata() { }
if (false) {
    /** @type {?|undefined} */
    ViewMetadata.prototype.tabs;
    /** @type {?|undefined} */
    ViewMetadata.prototype.tabsHeight;
    /** @type {?|undefined} */
    ViewMetadata.prototype.hasBottomTabs;
    /** @type {?|undefined} */
    ViewMetadata.prototype.header;
    /** @type {?|undefined} */
    ViewMetadata.prototype.headerHeight;
    /** @type {?|undefined} */
    ViewMetadata.prototype.bottomSpace;
}
/**
 * @record
 */
function FooterTab() { }
if (false) {
    /** @type {?|undefined} */
    FooterTab.prototype.x;
    /** @type {?|undefined} */
    FooterTab.prototype.y;
    /** @type {?|undefined} */
    FooterTab.prototype.upperLeftRadius;
    /** @type {?|undefined} */
    FooterTab.prototype.upperRightRadius;
    /** @type {?|undefined} */
    FooterTab.prototype.backgroundColor;
    /** @type {?|undefined} */
    FooterTab.prototype.color;
    /** @type {?|undefined} */
    FooterTab.prototype.content;
}
/** @enum {number} */
var IonPullUpFooterState = {
    Collapsed: 0,
    Expanded: 1,
    Minimized: 2,
};
IonPullUpFooterState[IonPullUpFooterState.Collapsed] = 'Collapsed';
IonPullUpFooterState[IonPullUpFooterState.Expanded] = 'Expanded';
IonPullUpFooterState[IonPullUpFooterState.Minimized] = 'Minimized';
/** @enum {number} */
var IonPullUpFooterBehavior = {
    Hide: 0,
    Expand: 1,
};
IonPullUpFooterBehavior[IonPullUpFooterBehavior.Hide] = 'Hide';
IonPullUpFooterBehavior[IonPullUpFooterBehavior.Expand] = 'Expand';
var IonicPullupComponent = /** @class */ (function () {
    function IonicPullupComponent(platform, el, renderer, hammerConfig) {
        this.platform = platform;
        this.el = el;
        this.renderer = renderer;
        this.hammerConfig = hammerConfig;
        this.stateChange = new EventEmitter();
        this.expanded = new EventEmitter();
        this.collapsed = new EventEmitter();
        this.minimized = new EventEmitter();
        this.footerMeta = {
            height: 0,
            posY: 0,
            lastPosY: 0
        };
        this.currentViewMeta = { bottomSpace: screen.height - window.innerHeight };
        // sets initial state
        this.initialState = this.initialState || IonPullUpFooterState.Collapsed;
        this.defaultBehavior = this.defaultBehavior || IonPullUpFooterBehavior.Expand;
        this.maxHeight = this.maxHeight || 0;
    }
    /**
     * @return {?}
     */
    IonicPullupComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        console.log('ionic-pullup => Initializing footer...');
        window.addEventListener('orientationchange', (/**
         * @return {?}
         */
        function () {
            console.log('ionic-pullup => Changed orientation => updating');
            _this.updateUI();
        }));
        this.platform.resume.subscribe((/**
         * @return {?}
         */
        function () {
            console.log('ionic-pullup => Resumed from background => updating');
            _this.updateUI();
        }));
    };
    /**
     * @return {?}
     */
    IonicPullupComponent.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        this.computeDefaults();
        this.state = IonPullUpFooterState.Collapsed;
        this.updateUI();
    };
    Object.defineProperty(IonicPullupComponent.prototype, "expandedHeight", {
        get: /**
         * @return {?}
         */
        function () {
            return window.innerHeight - this.currentViewMeta.headerHeight - this.currentViewMeta.tabsHeight;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    IonicPullupComponent.prototype.computeDefaults = /**
     * @return {?}
     */
    function () {
        var _this = this;
        setTimeout((/**
         * @return {?}
         */
        function () {
            _this.footerMeta.toolbarDefaultHeight = _this.childFooter.nativeElement.offsetHeight;
            _this.currentViewMeta.tabs = document.querySelector('ion-tab-bar');
            _this.currentViewMeta.tabsHeight = _this.currentViewMeta.tabs ? ((/** @type {?} */ (_this.currentViewMeta.tabs))).offsetHeight : 0;
            console.log(_this.currentViewMeta.tabsHeight ? 'ionic-pullup => Tabs detected' : 'ionic.pullup => View has no tabs');
            _this.currentViewMeta.header = document.querySelector('ion-toolbar');
            _this.currentViewMeta.headerHeight = _this.currentViewMeta.header.clientHeight;
            _this.footerMeta.ionContentRef = _this.childFooter.nativeElement.querySelector('ion-content');
            _this.dragElements.forEach((/**
             * @param {?} elem
             * @return {?}
             */
            function (elem) {
                /** @type {?} */
                var hammer = _this.hammerConfig.buildHammer(elem.el);
                hammer.on('pan panstart panend', (/**
                 * @param {?} ev
                 * @return {?}
                 */
                function (ev) {
                    _this.onPan(ev);
                }));
            }));
        }), 300);
    };
    /**
     * @return {?}
     */
    IonicPullupComponent.prototype.computeHeights = /**
     * @return {?}
     */
    function () {
        this.footerMeta.height = this.maxHeight > 0 ? this.maxHeight : this.expandedHeight;
        this.footerMeta.toolbarDefaultExpandedPosition = -this.footerMeta.height + this.footerMeta.toolbarDefaultHeight;
        this.footerMeta.toolbarUpperBoundary = this.footerMeta.height - this.currentViewMeta.headerHeight;
        this.renderer.setStyle(this.childFooter.nativeElement, 'height', this.footerMeta.height + 'px');
        this.renderer.setStyle(this.childFooter.nativeElement, 'top', window.innerHeight - this.footerMeta.toolbarDefaultHeight - this.currentViewMeta.tabsHeight + 'px');
        // TODO check if this is needed for native platform iOS/Android
        // this.renderer.setStyle(this.childFooter.nativeElement, 'bottom', this.currentViewMeta.tabsHeight + 'px');
    };
    /**
     * @param {?=} isInit
     * @return {?}
     */
    IonicPullupComponent.prototype.updateUI = /**
     * @param {?=} isInit
     * @return {?}
     */
    function (isInit) {
        var _this = this;
        if (isInit === void 0) { isInit = false; }
        if (!this.childFooter) {
            return;
        }
        setTimeout((/**
         * @return {?}
         */
        function () {
            _this.computeHeights();
        }), 300);
        this.renderer.setStyle(this.childFooter.nativeElement, 'transition', 'none'); // avoids flickering when changing orientation
    };
    /**
     * @return {?}
     */
    IonicPullupComponent.prototype.expand = /**
     * @return {?}
     */
    function () {
        console.log('Expand', this.childFooter);
        this.footerMeta.lastPosY = this.footerMeta.toolbarDefaultExpandedPosition;
        // reset ionContent scaling
        this.renderer.setStyle(this.footerMeta.ionContentRef, 'max-height', '100%');
        this.renderer.setStyle(this.childFooter.nativeElement, '-webkit-transform', "translate3d(0, " + this.footerMeta.lastPosY + "px, 0)");
        this.renderer.setStyle(this.childFooter.nativeElement, 'transform', "translate3d(0, " + this.footerMeta.lastPosY + "px, 0)");
        this.renderer.setStyle(this.childFooter.nativeElement, 'transition', '300ms ease-in-out');
        this.expanded.emit(null);
    };
    /**
     * @param {?=} isInit
     * @return {?}
     */
    IonicPullupComponent.prototype.collapse = /**
     * @param {?=} isInit
     * @return {?}
     */
    function (isInit) {
        if (isInit === void 0) { isInit = false; }
        console.log('Collapse', this.childFooter);
        if (!this.childFooter) {
            return;
        }
        this.footerMeta.lastPosY = 0;
        // reset ionContent scaling
        this.renderer.setStyle(this.footerMeta.ionContentRef, 'max-height', '100%');
        this.renderer.setStyle(this.childFooter.nativeElement, '-webkit-transform', "translate3d(0, " + this.footerMeta.lastPosY + "px, 0)");
        this.renderer.setStyle(this.childFooter.nativeElement, 'transform', "translate3d(0, " + this.footerMeta.lastPosY + "px, 0)");
        if (!isInit) {
            this.collapsed.emit(null);
        }
    };
    /**
     * TODO
     */
    /**
     * TODO
     * @return {?}
     */
    IonicPullupComponent.prototype.minimize = /**
     * TODO
     * @return {?}
     */
    function () {
        this.footerMeta.lastPosY = this.footerMeta.height;
        this.renderer.setStyle(this.childFooter.nativeElement, '-webkit-transform', 'translate3d(0, ' + this.footerMeta.lastPosY + 'px, 0)');
        this.renderer.setStyle(this.childFooter.nativeElement, 'transform', 'translate3d(0, ' + this.footerMeta.lastPosY + 'px, 0)');
        this.minimized.emit(null);
    };
    /**
     * @param {?} e
     * @return {?}
     */
    IonicPullupComponent.prototype.onTap = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        e.preventDefault();
        if (this.state === IonPullUpFooterState.Collapsed) {
            if (this.defaultBehavior === IonPullUpFooterBehavior.Hide) {
                this.state = IonPullUpFooterState.Minimized;
            }
            else {
                this.state = IonPullUpFooterState.Expanded;
            }
        }
        else {
            if (this.state === IonPullUpFooterState.Minimized) {
                if (this.defaultBehavior === IonPullUpFooterBehavior.Hide) {
                    this.state = IonPullUpFooterState.Collapsed;
                }
                else {
                    this.state = IonPullUpFooterState.Expanded;
                }
            }
            else {
                // footer is expanded
                this.state = this.initialState === IonPullUpFooterState.Minimized ? IonPullUpFooterState.Minimized : IonPullUpFooterState.Collapsed;
            }
        }
    };
    /**
     * @param {?} e
     * @return {?}
     */
    IonicPullupComponent.prototype.onPan = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        this.renderer.setStyle(this.childFooter.nativeElement, 'transition', 'none');
        e.preventDefault();
        switch (e.type) {
            case 'pan':
                this.footerMeta.posY = e.deltaY + this.footerMeta.lastPosY;
                // check for min and max boundaries overflow with sliding gesture
                if (this.footerMeta.posY > 0) {
                    this.footerMeta.posY = 0;
                    // return;
                }
                else if (Math.abs(this.footerMeta.posY) > this.footerMeta.toolbarUpperBoundary) {
                    this.footerMeta.posY = this.footerMeta.toolbarDefaultExpandedPosition;
                }
                // ionContent scaling - FIX scrolling bug
                if (this.footerMeta.ionContentRef) {
                    /** @type {?} */
                    var scaleFactor = Math.abs(this.footerMeta.posY) / this.footerMeta.toolbarUpperBoundary;
                    this.renderer.setStyle(this.footerMeta.ionContentRef, 'max-height', scaleFactor * 100 + "%");
                }
                this.renderer.setStyle(this.childFooter.nativeElement, '-webkit-transform', 'translate3d(0, ' + this.footerMeta.posY + 'px, 0)');
                this.renderer.setStyle(this.childFooter.nativeElement, 'transform', 'translate3d(0, ' + this.footerMeta.posY + 'px, 0)');
                break;
            case 'panend':
                this.renderer.setStyle(this.childFooter.nativeElement, 'transition', '300ms ease-in-out');
                this.footerMeta.lastPosY = this.footerMeta.posY;
                // TODO auto dock
                // if (this.footerMeta.lastPosY > this.footerMeta.height - this.footerMeta.defaultHeight) {
                //   this.state =  IonPullUpFooterState.Collapsed;
                // }
                break;
        }
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    IonicPullupComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        var _this = this;
        console.log(changes);
        if (changes.state.isFirstChange() || changes.state.currentValue === changes.state.previousValue) {
            return;
        }
        switch (this.state) {
            case IonPullUpFooterState.Collapsed:
                this.collapse();
                break;
            case IonPullUpFooterState.Expanded:
                this.expand();
                break;
            case IonPullUpFooterState.Minimized:
                this.minimize();
                break;
        }
        // this.oldState = this.state;
        // TODO: fix hack due to BUG (https://github.com/angular/angular/issues/6005)
        window.setTimeout((/**
         * @return {?}
         */
        function () {
            _this.stateChange.emit(_this.state);
        }));
    };
    IonicPullupComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-ionic-pullup',
                    template: "<div class=\"footer\" #footer>\n  <ng-content></ng-content>\n</div>",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    styles: [".footer{left:0;right:0;position:fixed}"]
                }] }
    ];
    /** @nocollapse */
    IonicPullupComponent.ctorParameters = function () { return [
        { type: Platform },
        { type: ElementRef },
        { type: Renderer2 },
        { type: HammerGestureConfig, decorators: [{ type: Inject, args: [HAMMER_GESTURE_CONFIG,] }] }
    ]; };
    IonicPullupComponent.propDecorators = {
        state: [{ type: Input }],
        stateChange: [{ type: Output }],
        initialState: [{ type: Input }],
        defaultBehavior: [{ type: Input }],
        maxHeight: [{ type: Input }],
        expanded: [{ type: Output }],
        collapsed: [{ type: Output }],
        minimized: [{ type: Output }],
        childFooter: [{ type: ViewChild, args: ['footer', { static: true },] }],
        dragElements: [{ type: ContentChildren, args: ['ionDragFooter',] }]
    };
    return IonicPullupComponent;
}());
if (false) {
    /** @type {?} */
    IonicPullupComponent.prototype.state;
    /** @type {?} */
    IonicPullupComponent.prototype.stateChange;
    /** @type {?} */
    IonicPullupComponent.prototype.initialState;
    /** @type {?} */
    IonicPullupComponent.prototype.defaultBehavior;
    /** @type {?} */
    IonicPullupComponent.prototype.maxHeight;
    /** @type {?} */
    IonicPullupComponent.prototype.expanded;
    /** @type {?} */
    IonicPullupComponent.prototype.collapsed;
    /** @type {?} */
    IonicPullupComponent.prototype.minimized;
    /** @type {?} */
    IonicPullupComponent.prototype.childFooter;
    /** @type {?} */
    IonicPullupComponent.prototype.dragElements;
    /**
     * @type {?}
     * @protected
     */
    IonicPullupComponent.prototype.footerMeta;
    /**
     * @type {?}
     * @protected
     */
    IonicPullupComponent.prototype.currentViewMeta;
    /**
     * @type {?}
     * @protected
     */
    IonicPullupComponent.prototype.oldState;
    /**
     * @type {?}
     * @private
     */
    IonicPullupComponent.prototype.platform;
    /**
     * @type {?}
     * @private
     */
    IonicPullupComponent.prototype.el;
    /**
     * @type {?}
     * @private
     */
    IonicPullupComponent.prototype.renderer;
    /**
     * @type {?}
     * @private
     */
    IonicPullupComponent.prototype.hammerConfig;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MyHammerConfig = /** @class */ (function (_super) {
    __extends(MyHammerConfig, _super);
    function MyHammerConfig() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.overrides = {
            pan: { direction: DIRECTION_VERTICAL },
        };
        return _this;
    }
    return MyHammerConfig;
}(HammerGestureConfig));
if (false) {
    /** @type {?} */
    MyHammerConfig.prototype.overrides;
}
var IonicPullupModule = /** @class */ (function () {
    function IonicPullupModule() {
    }
    IonicPullupModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [IonicPullupComponent, IonicPullupComponentTabComponent],
                    imports: [],
                    exports: [IonicPullupComponent, IonicPullupComponentTabComponent],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    providers: [
                        {
                            provide: HAMMER_GESTURE_CONFIG,
                            useClass: MyHammerConfig,
                        },
                    ]
                },] }
    ];
    return IonicPullupModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { IonPullUpFooterBehavior, IonPullUpFooterState, IonicPullupComponent, IonicPullupComponentTabComponent, IonicPullupModule, MyHammerConfig };
//# sourceMappingURL=ionic-pullup.js.map
