import { EventEmitter, ElementRef, Renderer2, OnInit, AfterContentInit, OnChanges, SimpleChanges, QueryList } from '@angular/core';
import { Platform } from '@ionic/angular';
import { HammerGestureConfig } from '@angular/platform-browser';
export interface FooterMetadata {
    height: number;
    posY: number;
    lastPosY: number;
    toolbarDefaultHeight?: number;
    toolbarDefaultExpandedPosition?: number;
    toolbarUpperBoundary?: number;
    ionContentRef?: any;
}
export interface ViewMetadata {
    tabs?: Element;
    tabsHeight?: number;
    hasBottomTabs?: boolean;
    header?: Element;
    headerHeight?: number;
    bottomSpace?: number;
}
export interface FooterTab {
    x?: number;
    y?: number;
    upperLeftRadius?: number;
    upperRightRadius?: number;
    backgroundColor?: string;
    color?: string;
    content?: string;
}
export declare enum IonPullUpFooterState {
    Collapsed = 0,
    Expanded = 1,
    Minimized = 2
}
export declare enum IonPullUpFooterBehavior {
    Hide = 0,
    Expand = 1
}
export declare class IonicPullupComponent implements OnInit, AfterContentInit, OnChanges {
    private platform;
    private el;
    private renderer;
    private hammerConfig;
    state: IonPullUpFooterState;
    stateChange: EventEmitter<IonPullUpFooterState>;
    initialState: IonPullUpFooterState;
    defaultBehavior: IonPullUpFooterBehavior;
    maxHeight: number;
    expanded: EventEmitter<any>;
    collapsed: EventEmitter<any>;
    minimized: EventEmitter<any>;
    childFooter: any;
    dragElements: QueryList<any>;
    protected footerMeta: FooterMetadata;
    protected currentViewMeta: ViewMetadata;
    protected oldState: IonPullUpFooterState;
    constructor(platform: Platform, el: ElementRef, renderer: Renderer2, hammerConfig: HammerGestureConfig);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    readonly expandedHeight: number;
    computeDefaults(): void;
    computeHeights(): void;
    updateUI(isInit?: boolean): void;
    expand(): void;
    collapse(isInit?: boolean): void;
    /**
     * TODO
     */
    minimize(): void;
    onTap(e: any): void;
    onPan(e: HammerInput): void;
    ngOnChanges(changes: SimpleChanges): void;
}
